/*t8OO5KxQQgGVFUMUJ9osWaGVRdJNj8hgdE/xL42HWqjzWH06923fvrvB8mCKr7NignsjVsj3fKNz
efGWu09XyA==*/
package nccloud.web.ssckm.kmclassify.action;

import java.util.Map;

import nc.bs.logging.Logger;
import nc.vo.ssckm.kmclassify.KmClassifyVO;
import nccloud.framework.core.exception.ExceptionUtils;
import nccloud.framework.core.json.IJson;
import nccloud.framework.service.ServiceLocator;
import nccloud.framework.web.action.itf.ICommonAction;
import nccloud.framework.web.container.IRequest;
import nccloud.framework.web.convert.pattern.GridConvertor;
import nccloud.framework.web.convert.translate.Translator;
import nccloud.framework.web.json.JsonFactory;
import nccloud.framework.web.ui.pattern.grid.Grid;
import nccloud.itf.ssckm.kmclassify.IKmClassifyService;
import nccloud.ssckm.param.pubconst.IKmConst;

/**
 * ֪ʶ-ȡ֪ʶ൵
 *
 * @since 2019418
 * @version 1909
 * @author chenshfc
 */
public class KmClassifyGetDataAction implements ICommonAction {

	@Override
	public Object doAction(IRequest request) {

		Grid grid = new Grid();
		try {
			// ǰ̨
			IJson json = JsonFactory.create();
			String read = request.read();
			Map<String, Object> view = json.fromJson(read, Map.class);
			// ֪ʶʾͣǷѡ
			boolean showUnuse = (boolean) view.get(IKmConst.SHOWUNUSE);

			// ѯӿ
			KmClassifyVO[] resultvos = ServiceLocator.find(IKmClassifyService.class)
					.classifyGetData(showUnuse);
			if (resultvos == null || resultvos.length == 0)
				return null;

			// voתgrid
			GridConvertor gc = new GridConvertor();
			grid = gc.toGrid(IKmConst.CLASSIFY_HEADCODE, resultvos);
			grid.setPageid(IKmConst.CLASSIFY_PAGECODE);
			grid.setTempletid(IKmConst.CLASSIFY_TEMPLATEID);

			// grid
			Translator translator = new Translator();
			translator.translate(grid);
		} catch (Exception e) {
			Logger.error(e.getMessage(), e);
			ExceptionUtils.wrapException(e);
		}

		return grid;
	}
}

/*t8OO5KxQQgGVFUMUJ9osWaGVRdJNj8hgdE/xL42HWqjzWH06923fvrvB8mCKr7NignsjVsj3fKNz
efGWu09XyA==*/