/*PRiQmvhQyfVOvDg+dn+DBE2mftKfLgM6WDEI8qfh7bDpRE21Y7ONqQbJjuYGPJ86ht7OucB+MU3G
kHaR93DVkw==*/
package nccloud.web.ssckm.kmclassify.action;

import java.util.Arrays;
import java.util.List;
import java.util.stream.Collectors;

import nc.bs.dao.BaseDAO;
import nc.bs.dao.DAOException;
import nc.bs.logging.Logger;
import nc.jdbc.framework.processor.ColumnProcessor;
import nc.vo.bd.meta.BatchOperateVO;
import nc.vo.ssckm.kmclassify.KmClassifyVO;
import nccloud.framework.core.exception.ExceptionUtils;
import nccloud.framework.core.json.IJson;
import nccloud.framework.service.ServiceLocator;
import nccloud.framework.web.action.itf.ICommonAction;
import nccloud.framework.web.container.IRequest;
import nccloud.framework.web.convert.pattern.GridConvertor;
import nccloud.framework.web.convert.translate.Translator;
import nccloud.framework.web.json.JsonFactory;
import nccloud.framework.web.ui.pattern.grid.Grid;
import nccloud.itf.ssckm.kmclassify.IKmClassifyService;
import nccloud.ssckm.param.pubconst.IKmConst;
import nccloud.util.ssckm.pub.SSCKMDataTableUtil;

/**
 * ֪ʶ-֪ʶౣ
 *
 * @since 2019418
 * @version 1909
 * @author chenshfc
 */
public class KmClassifySaveAction implements ICommonAction {

	@Override
	public Object doAction(IRequest request) {
		IJson json = JsonFactory.create();
		String read = request.read();
		Grid grid = json.fromJson(read, Grid.class);
		try {
			// gridתvo
			GridConvertor gc = new GridConvertor();
			KmClassifyVO[] vos = gc.fromGrid(KmClassifyVO.class, grid);
			
			vos = this.newVOGetParent(vos);

			// ñӿ
			KmClassifyVO[] resultvos = ServiceLocator.find(IKmClassifyService.class).classifySave(
					vos);
			if (resultvos != null && resultvos.length == 0) {
				return null;
			}
			//BatchOperateVO retvo = SSCKMDataTableUtil.setBatchOperateVO(vos);

			// voתgrid
			grid = gc.toGrid(IKmConst.CLASSIFY_HEADCODE, resultvos);

			// 
			Translator translator = new Translator();
			translator.translate(grid);
		} catch (Exception e) {
			Logger.error(e.getMessage(), e);
			ExceptionUtils.wrapException(e);
		}
		return grid;
	}
	
	/**
	 * 	vopk_parent 202241215:04:43
	 * @author guojx
	 * @return
	 */
	private KmClassifyVO[] newVOGetParent(KmClassifyVO[] vos) {
		BatchOperateVO retvo = SSCKMDataTableUtil.setBatchOperateVO(vos);
		Object[] newVOs =  retvo.getAddObjs();
		Object[] adjustVOs = retvo.getUpdObjs();
		KmClassifyVO[] newKMVOs = Arrays.stream(newVOs).map(x->(x)).collect(Collectors.toList()).toArray(new KmClassifyVO[0]);
		KmClassifyVO[] adjustKMVOs = Arrays.stream(adjustVOs).map(x->(x)).collect(Collectors.toList()).toArray(new KmClassifyVO[0]);
		this.checkAdjustVO(adjustKMVOs);
		//update by guojx ޸ĵ 20220418
		KmClassifyVO[][] collections = new KmClassifyVO[][] {newKMVOs,adjustKMVOs};
//		int[] lengths = Arrays.stream(newKMVOs).map(KmClassifyVO::getCode).collect(Collectors.toList()).toArray(new int[0]);
		//߼ٴȫֽж
		Arrays.stream(collections).forEach(x->{
			for(int i=0;i<x.length;i++) {
				int length = x[i].getCode().length();
				final KmClassifyVO vo = x[i];
				if(length==2) {
					//pass
				}else {
					List<String> pk_parents = Arrays.stream(vos).filter(y->(y.getCode().equals(vo.getCode().substring(0, length-2)))&&!y.getCode().equals(vo.getCode())).map(KmClassifyVO::getPrimaryKey).collect(Collectors.toList());
					if(pk_parents.size()!=0) {
						String pk_parent = pk_parents.get(0);
//						newKMVOs[i].setPk_parent(pk_parent);
						Arrays.stream(vos).forEach(z->{
							if(z.getCode().equals(vo.getCode())) {
								z.setPk_parent(pk_parent);
							}
						});
					}
				}
			}
		});
		
		return vos;
	}
	
	private void checkAdjustVO(KmClassifyVO[] adjustKMVOs) {
		BaseDAO baseDao = new BaseDAO();
		if(adjustKMVOs.length>0) {
		
		//޸Ĳ޸̫in
		for(KmClassifyVO adjustKMVO : adjustKMVOs) {
			try {
				String originCode = (String) baseDao.executeQuery("select code from ssckm_classify where pk_classify = '"+adjustKMVO.getPk_classify()+"'", new ColumnProcessor());
				if((adjustKMVO.getCode().length()!=originCode.length())) {
					ExceptionUtils.wrapBusinessException("벻㼶޸!->pk"+adjustKMVO.getPk_classify());
				}
			} catch (DAOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
//		String[] allPk = Arrays.stream(adjustKMVOs).map(KmClassifyVO::getPrimaryKey).collect(Collectors.toList()).toArray(new String[0]);
		
	}
	}
}

/*PRiQmvhQyfVOvDg+dn+DBE2mftKfLgM6WDEI8qfh7bDpRE21Y7ONqQbJjuYGPJ86ht7OucB+MU3G
kHaR93DVkw==*/