/*Gv9AlyDMdLJ+SyBORnXKb/jFvqg7QkGhyutTpOpZ5xir03o/ux67UPl9Tfh5ZyD6pu8vyWD8irri
KxgtE7y1wA==*/
package nccloud.web.ssckm.kmsearch.action;


import java.util.HashMap;
import java.util.Map;

import nc.bs.logging.Logger;
import nc.bs.sscrp.pub.query.PageInfo;
import nc.vo.ssckm.kmknowledge.KmKnowledgeVO;
import nccloud.framework.core.exception.ExceptionUtils;
import nccloud.framework.core.json.IJson;
import nccloud.framework.service.ServiceLocator;
import nccloud.framework.web.action.itf.ICommonAction;
import nccloud.framework.web.container.IRequest;
import nccloud.framework.web.convert.pattern.GridConvertor;
import nccloud.framework.web.convert.translate.Translator;
import nccloud.framework.web.json.JsonFactory;
import nccloud.framework.web.ui.pattern.grid.Grid;
import nccloud.itf.ssckm.kmsearch.IKmSearchService;
import nccloud.ssckm.param.pubconst.IKmConst;
import nccloud.web.ssckm.client.util.KmClientCommonUtil;

import com.google.gson.JsonObject;

/**
 *֪ʶ-֪ʶ
 *
 * @since 2019418
 * @version 1909
 * @author chenshfc
 */
public class KmSearchFuzzyQueryAction implements ICommonAction {

	@Override
	public Object doAction(IRequest request) {
	    IJson json = JsonFactory.create();
	    IKmSearchService service = ServiceLocator.find(IKmSearchService.class);
	    Map<String,Object> result = new HashMap<String,Object>();
		try {
		    String read = request.read();
		    Map<String,Object> parammap = json.fromJson(read, Map.class);
		    
		    Grid grid = new Grid();
		    GridConvertor gc = new GridConvertor();
		    KmKnowledgeVO[] resultvos = null;
		    int total = 0;
		    
		    //ȡѯ
			total = service.countFuzzyQuery(parammap);
			if(total == 0){
				return null;
			}
			
			//ȡҳ
		    PageInfo pageinfo = KmClientCommonUtil.getPageInfo(parammap);
			
			//ȡѯ
			resultvos = service.searchFuzzyQuery(parammap,pageinfo);	
			if(resultvos == null || resultvos.length ==0){
				return null;
			}
			
			//VOתGrid
			grid = gc.toGrid(IKmConst.SEARCH_HEADCODE, resultvos);
			grid.setPageid(IKmConst.SEARCH_PAGECODE);
		 	grid.setTempletid(IKmConst.SEARCH_TEMPLATEID);
		 	Translator translator = new Translator();
		 	translator.translate(grid);
		 	
		 	//÷ҳϢ
		 	pageinfo.setTotal(total);
			if(total % pageinfo.getPageSize() > 0){
				pageinfo.setTotalPage(total / pageinfo.getPageSize() + 1);
			}else{
				pageinfo.setTotalPage(total / pageinfo.getPageSize());
			}
			JsonObject pageInfoJson = new JsonObject();
			pageInfoJson.addProperty("number", pageinfo.getPageIndex());
			pageInfoJson.addProperty("size", pageinfo.getPageSize());
			pageInfoJson.addProperty("totalElements", pageinfo.getTotal());
			pageInfoJson.addProperty("totalPages", pageinfo.getTotalPage());
			
			//װ
			result.put("pageinfo", pageInfoJson);
			result.put("data", grid);
			
		} catch (Exception e) {
			// TODO 쳣δ
			Logger.error(e.getMessage(), e);
			ExceptionUtils.wrapException(e);
		}
		return result;
	}
}

/*Gv9AlyDMdLJ+SyBORnXKb/jFvqg7QkGhyutTpOpZ5xir03o/ux67UPl9Tfh5ZyD6pu8vyWD8irri
KxgtE7y1wA==*/