package nccloud.web.action.ssckm.record;

import java.util.Map;

import nc.bs.dao.BaseDAO;
import nc.bs.dao.DAOException;
import nc.bs.framework.common.InvocationInfoProxy;
import nc.bs.framework.json.core.exception.ExceptionUtils;
import nc.jdbc.framework.SQLParameter;
import nc.jdbc.framework.processor.ColumnProcessor;
import nccloud.framework.core.json.IJson;
import nccloud.framework.service.ServiceLocator;
import nccloud.framework.web.action.itf.ICommonAction;
import nccloud.framework.web.container.IRequest;
import nccloud.framework.web.container.SessionContext;
import nccloud.framework.web.json.JsonFactory;

/**
 *  ¼ļ򿪴
 * @author guojx
 *	20220418
 */
public class RecordBill implements ICommonAction {
	
	private BaseDAO baseDao = new BaseDAO();

	@Override
	public Object doAction(IRequest request) {
		// ǰ̨
		IJson json = JsonFactory.create();
		String pk_user = SessionContext.getInstance().getClientInfo().getUserid();
		String billid = request.read();;
		try {
		SQLParameter params = new SQLParameter();
		params.addParam(pk_user);
		params.addParam(billid);
		Object times =  baseDao.executeQuery("select times from knowledge_record where pk_user = ? and billid = ?", params , new ColumnProcessor());
		if(times!=null) {
			baseDao.executeUpdate("update knowledge_record set times = times + 1 where pk_user = ? and billid = ?",params);
		}else {
			baseDao.executeUpdate("insert into knowledge_record (pk_user,billid) values (?,?)",params);
		}
		} catch (DAOException e) {
			ExceptionUtils.wrapBusinessException(e.getMessage());
		}
		
		return null;
	}



}
